"use strict";
this.name = "Cabal_Common_Briefing";
this.author = "Svengali";
this.copyright = "(C)2010-2013, License:CC-by";
this.description = "Helper for Mission - Briefings.";
this.version = "1.7";

this.startUp = function()
{
	delete this.startUp;
	this.helper = new this.Cabal_Common_ScreenFCB();
	this.briefingSoundA = new SoundSource();
	this.briefingSoundB = new SoundSource();
}
// Can be called via worldScripts.Cabal_Common_Briefing.startBriefing(obj);
this.startBriefing = function(obj)
{
	if(!player.ship.docked || !obj) return(false);
	if(!obj.capture){
		if(!obj.title) obj.title = "Briefing";
		if(!obj.background) obj.background = null;
		if(!obj.fadeIn){
			if(!obj.overlay){
				var check = expandMissionText('BGS-IMAGESWITCH');
				if(check==="Yes") obj.overlay = "bgs-i_overlay_none.png";
				else obj.overlay = null;
			}
		} else obj.overlay = {name:"cabal_common_briefing_blend10.png",width:1024,height:480};
		if(!obj.music) obj.music = null;
		this.briefing = obj.briefing;
		if(obj.callbackc) this.briefing.cbc = obj.callbackc;
		else obj.callbackc = null;
		mission.runScreen({title:obj.title,model:obj.role,spinModel:false,background:obj.background,overlay:obj.overlay,music:obj.music,choicesKey:obj.callbackc},this.choiceEval);
		if(obj.cornerPos) this.helper.screenCornerPos(obj.cornerPos[0],obj.cornerPos[1],obj.cornerPos[2],obj.cornerPos[3]);
		if(obj.absolutePos) mission.displayModel.position = [obj.absolutePos[0],obj.absolutePos[1],obj.absolutePos[2]];
		if(obj.ori) mission.displayModel.orientation = obj.ori;
		if(obj.getOri) mission.displayModel.orientation = mission.displayModel.scriptInfo[obj.getOri].split(",");
		if(obj.getPos) mission.displayModel.position = mission.displayModel.scriptInfo[obj.getPos].split(",");
		if(obj.prepareProps){
			var prop;
			for(prop in obj.prepareProps){
				mission.displayModel[prop] = obj.prepareProps[prop];
				if(mission.displayModel.subEntities){
					for(var i=0;i<mission.displayModel.subEntities.length;i++) mission.displayModel.subEntities[i][prop] = obj.prepareProps[prop];
				}
			}
		}
		if(obj.prepareBindings) for(var b=0;b<obj.prepareBindings.length;b++) this.helper.fcbSetBinding(obj.prepareBindings[b][0],obj.prepareBindings[b][1],obj.prepareBindings[b][2],obj.prepareBindings[b][3],obj.prepareBindings[b][4],obj.prepareBindings[b][5],obj.prepareBindings[b][6]);
		if(obj.preparePositions) for(var p=0;p<obj.preparePositions.length;p++) this.helper.rePosition(obj.preparePositions[p][0],obj.preparePositions[p][1],obj.preparePositions[p][2]);
		if(obj.prepareOrientations) for(var o=0;o<obj.prepareOrientations.length;o++) this.helper.reOrient(obj.prepareOrientations[o][0],obj.prepareOrientations[o][1],obj.prepareOrientations[o][2]);
	} else this.helper.fcbRemoveAll();
	if(obj.repRelative){ // relativePosition is meaningless for missionscreens
		var ar = [mission.displayModel],flagM,flag;
		if(mission.displayModel.subEntities && mission.displayModel.subEntities.length){
			for(var i=0;i<mission.displayModel.subEntities.length;i++) ar.push(mission.displayModel.subEntities[i]);
		}
		for(var s=0;s<ar.length;s++){
			flag = 0;
			flagM = 0;
			var a = ar[s].getShaders();
			var b = Object.keys(a);
			if(!b.length){
				a = ar[s].getMaterials();
				b = Object.keys(a);
				flagM = 1;
			}
			if(b.length){
				if(a[b[0]].hasOwnProperty("uniforms")){
					var prop;
					for(prop in a[b[0]].uniforms){
						if(a[b[0]].uniforms[prop]==="relativePosition"){
							a[b[0]].uniforms[prop]="position";
							flag = 1;
						}
					}
				}
				if(flag){
					if(flagM) ar[s].setMaterials(a);
					else ar[s].setShaders(a);
				}
			}
		}
	}
	if(obj.fadeIn) this.briefingFadeIn = obj.fadeIn;
	else this.briefingFadeIn = null;
	if(obj.screenHUD){
		player.ship.hud = obj.screenHUD;
		player.ship.hudHidden = false;
	}
	this.briefingCounter = 0;
	this.briefingIndex = 0;
	this.briefing = obj.briefing;
	if(obj.callback && obj.callbackf){
		this.briefing.cb = obj.callback;
		this.briefing.cbf = obj.callbackf;
	}
	if(obj.delta) this.helper.ccl_defaultDelta = obj.delta;
	else this.helper.ccl_defaultDelta = 0.015;
	if(!this.briefingTimer) this.briefingTimer = new Timer(this,this.doBriefingTimer,0,0.25);
	else this.briefingTimer.start();
	return(true);
}
this.cleanUp = function()
{
	if(this.briefingTimer){
		this.briefingTimer.stop();
		delete this.briefingTimer;
	}
}
this.choiceEval = function(choice){worldScripts.Cabal_Common_Briefing.delayChoice(choice); return;}
this.delayChoice = function(choice)
{
	this.cleanUp();
	this.helper.fcbRemoveAll();
	if(this.briefing.cb && this.briefing.cbf) worldScripts[this.briefing.cb][this.briefing.cbf](choice);
	if(this.briefingSoundA.isPlaying) this.briefingSoundA.stop();
	if(this.briefingSoundB.isPlaying) this.briefingSoundB.stop();
	this.helper.ccl_defaultDelta = 0.015;
	delete this.briefing;
	player.ship.hud = null;
	return;
}
this.doBriefingTimer = function()
{
	if(!this.briefing.length || !mission.displayModel || !mission.displayModel.isValid || this.briefingIndex>=this.briefing.length){
		this.cleanUp();
		this.helper.fcbRemoveAll();
		return;
	}
	if(this.soundStopper && this.briefingCounter >= this.soundStopper[0]){
		if(this.soundStopper[1]) if(this.briefingSoundB.isPlaying) this.briefingSoundB.stop();
		else if(this.briefingSoundA.isPlaying) this.briefingSoundA.stop();
		delete this.soundStopper;
	}
	var current = this.briefing[this.briefingIndex];
	if(this.briefingCounter >= current[0]){
		// Action commands
		switch(current[1]){
			case "bgzoom":
				this.helper.fcbZoomBackground(current[2][0],current[2][1],current[2][2],current[2][3],current[2][4],current[2][5],current[2][6]);
				break;
			case "bind":
				this.helper.fcbSetBinding(current[2][0],current[2][1],current[2][2],current[2][3],current[2][4],current[2][5],current[2][6]);
				break;
			case "check":
				this.helper.fcbCheckAll();
				break;
			case "clean":
				this.helper.fcbRemoveAll();
				break;
			case "continue":
				var checked=false;
				if(this.briefing.cb){
					if(worldScripts[this.briefing.cb][current[2][0]]){
						checked = worldScripts[this.briefing.cb][current[2][0]](current[2][1]);
						if(typeof(checked)==='number'){ // Goto
							this.helper.fcbRemoveAll();
							this.briefingCounter = checked-1;
							this.briefingIndex = checked-1;
						}
					}
				}
				if(!checked && typeof(checked)!=='number'){
					this.cleanUp();
					this.helper.fcbRemoveAll();
					if(this.briefingSoundA.isPlaying && (this.briefingSoundA.repeatCount>1 || this.briefingSoundA.loop)) this.briefingSoundA.stop()
					if(this.briefingSoundB.isPlaying && (this.briefingSoundB.repeatCount>1 || this.briefingSoundB.loop)) this.briefingSoundB.stop()
				}
				break;
			case "face":
				this.helper.fcbFace(current[2][0],current[2][1],current[2][2],current[2][3],current[2][4],current[2][5],current[2][6],current[2][7]);
				break;
			case "flightTo":
				this.helper.fcbFlightTo(current[2][0],current[2][1],current[2][2],current[2][3],current[2][4],current[2][5],current[2][6],current[2][7]);
				break;
			case "revolution":
				this.helper.fcbKIRevolution(current[2][0],current[2][1],current[2][2],current[2][3],current[2][4]);
				break;
			case "kill":
				this.cleanUp();
				this.helper.fcbRemoveAll();
				if(this.briefingSoundA.isPlaying) this.briefingSoundA.stop();
				if(this.briefingSoundB.isPlaying) this.briefingSoundB.stop();
				if(this.briefing.cb && this.briefing.cbf) worldScripts[this.briefing.cb][this.briefing.cbf](current[2]);
				break;
			case "shadeprop":
				this.helper.reShaderProps(current[2][0],current[2][1],current[2][2],current[2][3],current[2][4]);
				break;
			case "mes":
				mission.addMessageText(current[2]);
				break;
			case "mSpeed":
				this.helper.fcbModelSpeed(current[2][0],current[2][1],current[2][2],current[2][3],current[2][4],current[2][5],current[2][6]);
				break;
			case "mVelo":
				this.helper.fcbModelVelo(current[2][0],current[2][1],current[2][2],current[2][3],current[2][4],current[2][5],current[2][6],current[2][7],current[2][8]);
				break;
			case "mVeloTo":
				this.helper.fcbModelVeloTo(current[2][0],current[2][1],current[2][2],current[2][3],current[2][4],current[2][5],current[2][6],current[2][7],current[2][8],current[2][9],current[2][10]);
				break;
			case "prop":
				this.helper.fcbSetProp(current[2][0],current[2][1],current[2][2],current[2][3],current[2][4],current[2][5],current[2][6]);
				break;
			case "reback":
				this.helper.reBackground(current[2][0]);
				break;
			case "reover":
				this.helper.reOverlay(current[2][0]);
				break;
			case "reori":
				this.helper.reOrient(current[2][0],current[2][1],current[2][2]);
				break;
			case "repos":
				this.helper.rePosition(current[2][0],current[2][1],current[2][2]);
				break;
			case "retex":
				this.helper.reTexture(current[2][0],current[2][1],current[2][2],current[2][3]);
				break;
			case "rot":
				this.helper.fcbRotation(current[2][0],current[2][1],current[2][2],current[2][3],current[2][4],current[2][5],current[2][6],current[2][7],current[2][8]);
				break;
			case "stopSound":
				if(this.briefingSoundA.isPlaying) this.briefingSoundA.stop();
				if(this.briefingSoundB.isPlaying) this.briefingSoundB.stop();
				break;
			case "stopVelo":
				this.helper.stopVelo(current[2][0],current[2][1]);
				break;
			case "turn":
				this.helper.fcbFlight(current[2][0],current[2][1],current[2][2],current[2][3],current[2][4],current[2][5],current[2][6]);
				break;
			case "walk":
				this.helper.fcbWalk(current[2][0],current[2][1],current[2][2],current[2][3],current[2][4],current[2][5],current[2][6],current[2][7]);
				break;
			case "zoom":
				this.helper.fcbZoom(current[2][0],current[2][1],current[2][2],current[2][3],current[2][4],current[2][5],current[2][6]);
				break;
		}
		if(current[3]) mission.addMessageText(current[3]);
		if(current[4]){
			if(!this.briefingSoundA.isPlaying){
				this.briefingSoundA.sound = current[4];
				if(current[5]) this.briefingSoundA.repeatCount = current[5];
				else this.briefingSoundA.repeatCount = 0;
				this.briefingSoundA.play();
				if(current[6]){
					if(!current[7]) this.briefingSoundB.stop();
					else this.soundStopper = [current[6],0]
				}
			} else {
				this.briefingSoundB.sound = current[4];
				if(current[5]) this.briefingSoundB.repeatCount = current[5];
				else this.briefingSoundB.repeatCount = 0;
				this.briefingSoundB.play();
				if(current[6]){
					if(!current[7]) this.briefingSoundA.stop();
					else this.soundStopper = [current[6],1]
				}
			}
		}
		this.briefingIndex++;
	}
	if(this.briefingCounter<11 && this.briefingFadeIn){
		var ind = 10-this.briefingCounter;
		var ovn = "cabal_common_briefing_blend"+ind+".png";
		setScreenOverlay({name:ovn,width:1024,height:480});
	}
	this.briefingCounter++;
	return;
}
this.shipWillLaunchFromStation = function()
{
	this.cleanUp();
	if(this.helper.ccl_briefing_fcbs.length) this.helper.fcbRemoveAll();
	if(this.briefingSoundA.isPlaying) this.briefingSoundA.stop();
	if(this.briefingSoundB.isPlaying) this.briefingSoundB.stop();
	delete this.briefing;
}
// API
this.Cabal_Common_ScreenFCB = function(){}
Cabal_Common_ScreenFCB.prototype = {
	constructor: Cabal_Common_ScreenFCB,
	internalVersion: 15,
	ccl_briefing_fcb: 0,
	ccl_briefing_fcbs: [],
	ccl_briefing_bg: 1,
	ccl_defaultDelta: 0.015,
	/* Face target.
		ent			Entity. To be reoriented. If not specified mission.displayModel.
		sub			SubEntity. If -1 main entity is used, otherwise ent.subEntities[sub].
		last		Number. Duration for fcb.
		tar			Entity. Target entity. If -1 player.ship is used.
		basez		Boolean. If true Z position will be taken into account.
		dampa		Number. Linear dampening duration for rotation start.
		dampb		Number. Linear dampening duration for rotation end.
		away		Number. Multiplier to head away from target. -1...1. */
	fcbFace: function(ent,sub,last,tar,basez,dampa,dampb,away){
		var ccl_sum = 0,ccl_ent = ent,ccl_sub = sub,ccl_last = last,ccl_delta=this.ccl_defaultDelta,ccl_tar = tar,ccl_basez = basez,ccl_dampa = dampa,ccl_dampb = dampb,ccl_away = away;
		if(!ent){
			if(ccl_sub===-1) ccl_ent = mission.displayModel;
			else ccl_ent = mission.displayModel.subEntities[ccl_sub];
			if(tar===-1) ccl_tar = player.ship;
			else ccl_tar = mission.displayModel.subEntities[tar];
		} else {
			if(tar===-1) ccl_tar = player.ship;
		}
		this.ccl_briefing_fcb = addFrameCallback(function(delta){
			if(!delta || !ccl_ent || !ccl_tar || !ccl_ent.isValid || !ccl_tar.isValid) return;
			var f=1-(ccl_delta-delta);
			ccl_sum += (delta*f);
			if(ccl_sum>=ccl_last) return;
			var bz = 1,da = 1,db = 1;
			if(ccl_basez) bz = 1-1/Math.sqrt(Math.max(Math.abs(ccl_ent.position.z),0.001));
			if(ccl_dampa && ccl_sum<ccl_dampa) da = 1-((ccl_dampa-ccl_sum)/ccl_dampa);
			if(ccl_dampb && ccl_sum>ccl_last-ccl_dampb) db = (ccl_last-ccl_sum)/ccl_dampb;
			var targetVector = ccl_tar.heading.subtract(ccl_ent.position).direction();
			var angle = (ccl_ent.heading.angleTo(targetVector)*bz*da*db/ccl_last/8)*ccl_away*f;
			var cross = ccl_ent.heading.cross(targetVector).direction();
			ccl_ent.orientation = ccl_ent.orientation.rotate(cross,-angle);
			return;
		});
		this.ccl_briefing_fcbs.push(this.ccl_briefing_fcb);
		return;
	},
	/* Flight.
		ent			Entity. To be reoriented and/or accelerated. If not specified mission.displayModel.
		sub			SubEntity. If -1 main entity is used, otherwise ent.subEntities[sub].
		last		Number. Duration for fcb.
		rU			Number. Rotate vectorUp by rU (radians).
		rR			Number. Rotate vectorRight by rR /radians).
		rF			Number. Rotate vectorForward by rF (radians).
		velo		Number. Multiply vectorForward and set velocity. If -1 no velocity set. */
	fcbFlight: function(ent,sub,last,rU,rR,rF,velo){
		var ccl_sum = 0,ccl_ent = ent,ccl_sub = sub,ccl_last = last,ccl_delta=this.ccl_defaultDelta,ccl_rU = rU,ccl_rR = rR,ccl_rF = rF,ccl_velo = velo;
		if(!ent) ccl_ent = mission.displayModel;
		this.ccl_briefing_fcb = addFrameCallback(function(delta){
			if(!delta || !ccl_ent || !ccl_ent.isValid) return;
			var f=1-(ccl_delta-delta);
			ccl_sum += (delta*f);
			if(ccl_sum>=ccl_last) return;
			if(ccl_sub>-1){
				if(ccl_rU) ccl_ent.subEntities[ccl_sub].orientation = ccl_ent.subEntities[ccl_sub].orientation.rotate(ccl_ent.subEntities[ccl_sub].vectorUp,ccl_rU*f);
				if(ccl_rR) ccl_ent.subEntities[ccl_sub].orientation = ccl_ent.subEntities[ccl_sub].orientation.rotate(ccl_ent.subEntities[ccl_sub].vectorRight,ccl_rR*f);
				if(ccl_rF) ccl_ent.subEntities[ccl_sub].orientation = ccl_ent.subEntities[ccl_sub].orientation.rotate(ccl_ent.subEntities[ccl_sub].vectorForward,ccl_rF*f);
				if(ccl_velo!==-1) ccl_ent.subEntities[ccl_sub].velocity = ccl_ent.subEntities[ccl_sub].vectorForward.multiply(ccl_velo*f);
			} else {
				if(ccl_rU) ccl_ent.orientation = ccl_ent.orientation.rotate(ccl_ent.vectorUp,ccl_rU*f);
				if(ccl_rR) ccl_ent.orientation = ccl_ent.orientation.rotate(ccl_ent.vectorRight,ccl_rR*f);
				if(ccl_rF) ccl_ent.orientation = ccl_ent.orientation.rotate(ccl_ent.vectorForward,ccl_rF*f);
				if(ccl_velo!==-1) ccl_ent.velocity = ccl_ent.vectorForward.multiply(ccl_velo*f);
			}
			return;
		});
		this.ccl_briefing_fcbs.push(this.ccl_briefing_fcb);
		return;
	},
	/* FlightTo.
		ent			mission.displayModel.subentity. To be reoriented and/or accelerated.
		tar			mission.displayModel.subentity. Target.position
		last		Number. Duration for fcb.
		dampa		Number. Linear dampening duration for rotation start.
		dampb		Number. Linear dampening duration for rotation end.
		mul			Number. Multiplier for rotation.
		velo		Number. Multiply vectorForward and set velocity.
		offset		Vector/Array. Offset position for target. */
	fcbFlightTo: function(ent,tar,last,dampa,dampb,mul,velo,offset){
		var ccl_sum = 0,ccl_ent = mission.displayModel.subEntities[ent],ccl_tar = mission.displayModel.subEntities[tar],ccl_last = last,ccl_delta=this.ccl_defaultDelta,ccl_dampa = dampa,ccl_dampb = dampb,ccl_mul = mul,ccl_velo = velo,ccl_offset = new Vector3D(offset);
		this.ccl_briefing_fcb = addFrameCallback(function(delta){
			if(!delta || !ccl_ent || !ccl_tar || !ccl_ent.isValid || !ccl_tar.isValid) return;
			var f=1-(ccl_delta-delta);
			ccl_sum += (delta*f);
			if(ccl_sum>=ccl_last) return;
			var da = 1,db = 1;
			if(ccl_sum<ccl_dampa) da = 1-((ccl_dampa-ccl_sum)/ccl_dampa);
			if(ccl_sum>ccl_last-ccl_dampb) db = (ccl_last-ccl_sum)/ccl_dampb;
			var targetVector = ccl_tar.position.add(ccl_offset).subtract(ccl_ent.position).direction();
			var angle = (ccl_ent.heading.angleTo(targetVector)*da*db/ccl_mul)*f;
			var cross = ccl_ent.heading.cross(targetVector).direction();
			ccl_ent.orientation = ccl_ent.orientation.rotate(cross,-angle);
			if(ccl_velo!==-1){
				var s = ccl_tar.position.add(ccl_offset).distanceTo(ccl_ent.position);
				if(s<ccl_ent.collisionRadius){ccl_sum=9999999; return;}
				var c = ccl_tar.collisionRadius*2;
				var m = 1;
				if(s<c) m = 1/Math.sqrt(c/s);
				ccl_ent.velocity = ccl_ent.vectorForward.multiply(ccl_velo*m*f);
			}
			return;
		});
		this.ccl_briefing_fcbs.push(this.ccl_briefing_fcb);
		return;
	},
	/* Forward KI for revolution joints
		start		Number. Subentity #
		end			Number. Subentity #
		last		Number. Duration for fcb.
		joints		Array. Vectors for connection points
		angles		Array. Max angle (dot product) before reorientation starts
	*/
	fcbKIRevolution: function(start,end,last,joints,angles){
		var ccl_sum=0,ccl_substart=start+1,ccl_subend=end+1,ccl_last=last,ccl_delta=this.ccl_defaultDelta,ccl_joints=joints,ccl_angles=angles;
		var ccl_ent = mission.displayModel,ccl_stepBack = [];
		for(var o=0;o<ccl_subend-ccl_substart;o++) ccl_stepBack.push(0);
		this.ccl_briefing_fcb = addFrameCallback(function(delta){
			if(!delta || !ccl_ent || !ccl_ent.isValid) return;
			var f=1-(ccl_delta-delta);
			ccl_sum += (delta*f);
			if(ccl_sum>=ccl_last) return;
			var vtr;
			for(var i=ccl_substart;i<ccl_subend;i++){
				var offset = new Vector3D(ccl_joints[i-1]),n0 = ccl_ent.subEntities[i-1],n1=ccl_ent.subEntities[i];
				var vt0 = n0.vectorForward,vt1=n1.vectorForward;
				var dt = vt0.dot(vt1);
				if(dt<ccl_angles[i-1] || ccl_stepBack[i]){
					var vt = n0.position.subtract(n1.position).direction();
					var angle = vt1.angleTo(vt)*0.01*f;
					var cross = vt1.cross(vt).direction();
					n1.orientation = n1.orientation.rotate(cross,angle);
					ccl_stepBack[i] = 1;
				}
				if(dt>0.999) ccl_stepBack[i] = 0;
				vtr = offset.rotateBy(n0.orientation);
				n1.position = vtr.add(n0.position);
				if(n0.velocity.magnitude()) n1.velocity=n0.velocity;
			}
			return;
		});
		this.ccl_briefing_fcbs.push(this.ccl_briefing_fcb);
		return;
	},
	/* Pseudospeed.
		ent			Entity. To be accelerated. If not specified mission.displayModel.
		sub			SubEntity. If -1 main entity is used, otherwise ent.subEntities[sub].
		last		Number. Duration for fcb.
		velo		Number. Multiply vectorForward and set velocity.
		basez		Boolean. If true Z position will be taken into account.
		dampa		Number. Linear dampening duration for velo start.
		dampb		Number. Linear dampening duration for velo end. */
	fcbModelSpeed: function(ent,sub,last,velo,basez,dampa,dampb){
		var ccl_sum = 0,ccl_sub = sub,ccl_last = last,ccl_delta=this.ccl_defaultDelta,ccl_ent = ent,ccl_velo = velo,ccl_basez = basez,ccl_dampa = dampa,ccl_dampb = dampb;
		if(!ent) ccl_ent = mission.displayModel;
		this.ccl_briefing_fcb = addFrameCallback(function(delta){
			if(!delta || !ccl_ent || !ccl_ent.isValid) return;
			var f=1-(ccl_delta-delta);
			ccl_sum += (delta*f);
			if(ccl_sum>=ccl_last) return;
			var bz = 1,da = 1,db = 1;
			if(ccl_basez) bz = Math.sqrt(Math.abs(ccl_ent.position.z));
			if(ccl_dampa && ccl_sum<ccl_dampa) da = 1-((ccl_dampa-ccl_sum)/ccl_dampa);
			if(ccl_dampb && ccl_sum>ccl_last-ccl_dampb) db = (ccl_last-ccl_sum)/ccl_dampb;
			if(ccl_sub>-1) ccl_ent.subEntities[sub].velocity = ccl_ent.vectorForward.multiply((ccl_velo*bz*da*db)*f);
			else ccl_ent.velocity = ccl_ent.vectorForward.multiply((ccl_velo*bz*da*db)*f);
			return;
		});
		this.ccl_briefing_fcbs.push(this.ccl_briefing_fcb);
		return;
	},
	/* Velocities.
		ent			Entity. If not specified mission.displayModel.
		sub			SubEntity. If -1 main entity is used, otherwise ent.subEntities[sub].
		last		Number. Duration for fcb.
		mU			Number. Multiplier vectorUp.
		mR			Number. Multiplier vectorRight.
		mF			Number. Multiplier vectorForward.
		basez		Boolean. If true Z position will be taken into account.
		dampa		Number. Linear dampening duration for start.
		dampb		Number. Linear dampening duration for end. */
	fcbModelVelo: function(ent,sub,last,mU,mR,mF,basez,dampa,dampb){
		var ccl_sum = 0,ccl_sub = sub,ccl_last = last,ccl_delta=this.ccl_defaultDelta,ccl_mU = mU,ccl_mR = mR,ccl_mF = mF,ccl_ent = ent,ccl_basez = basez,ccl_dampa = dampa,ccl_dampb = dampb;
		if(!ent) ccl_ent = mission.displayModel;
		this.ccl_briefing_fcb = addFrameCallback(function(delta){
			if(!delta || !ccl_ent || !ccl_ent.isValid) return;
			var f=1-(ccl_delta-delta);
			ccl_sum += (delta*f);
			if(ccl_sum>=ccl_last) return;
			var bz = 1,da = 1,db = 1;
			if(ccl_basez) bz = Math.sqrt(Math.abs(ccl_ent.position.z));
			if(ccl_dampa && ccl_sum<ccl_dampa) da = 1-((ccl_dampa-ccl_sum)/ccl_dampa);
			if(ccl_dampb && ccl_sum>ccl_last-ccl_dampb) db = (ccl_last-ccl_sum)/ccl_dampb;
			if(ccl_sub>-1){
				if(ccl_mU) ccl_ent.subEntities[ccl_sub].velocity = ccl_ent.subEntities[ccl_sub].vectorUp.multiply((ccl_mU*bz*da*db)*f);
				if(ccl_mR) ccl_ent.subEntities[ccl_sub].velocity = ccl_ent.subEntities[ccl_sub].vectorRight.multiply((ccl_mR*bz*da*db)*f);
				if(ccl_mF) ccl_ent.subEntities[ccl_sub].velocity = ccl_ent.subEntities[ccl_sub].vectorForward.multiply((ccl_mF*bz*da*db)*f);
			} else {
				if(ccl_mU) ccl_ent.velocity = ccl_ent.vectorUp.multiply((ccl_mU*bz*da*db)*f);
				if(ccl_mR) ccl_ent.velocity = ccl_ent.vectorRight.multiply((ccl_mR*bz*da*db)*f);
				if(ccl_mF) ccl_ent.velocity = ccl_ent.vectorForward.multiply((ccl_mF*bz*da*db)*f);
			}
			return;
		});
		this.ccl_briefing_fcbs.push(this.ccl_briefing_fcb);
		return;
	},
	/* Velocities.
		ent			Entity. If not specified mission.displayModel.
		sub			SubEntity. If -1 main entity is used, otherwise ent.subEntities[sub].
		last		Number. Duration for fcb.
		mU			Number. Multiplier vectorUp.
		mR			Number. Multiplier vectorRight.
		mF			Number. Multiplier vectorForward.
		basez		Boolean. If true Z position will be taken into account.
		dampa		Number. Linear dampening duration for start.
		dampb		Number. Linear dampening duration for end.
		tar			SubEntity.
		offset		Vector/Array. Offset for target position. */
	fcbModelVeloTo: function(ent,sub,last,mU,mR,mF,basez,dampa,dampb,tar,offset){
		var ccl_sum = 0,ccl_sub = sub,ccl_last = last,ccl_delta=this.ccl_defaultDelta,ccl_mU = mU,ccl_mR = mR,ccl_mF = mF,ccl_ent = ent,ccl_basez = basez,ccl_dampa = dampa,ccl_dampb = dampb,ccl_tar = mission.displayModel.subEntities[tar],ccl_offset=offset;
		if(!ent) ccl_ent = mission.displayModel;
		else ccl_ent = mission.displayModel.subEntity[ent];
		this.ccl_briefing_fcb = addFrameCallback(function(delta){
			if(!delta || !ccl_ent || !ccl_ent.isValid) return;
			var f=1-(ccl_delta-delta);
			ccl_sum += (delta*f);
			if(ccl_sum>=ccl_last) return;
			var bz = 1,da = 1,db = 1;
			if(ccl_basez) bz = Math.sqrt(Math.abs(ccl_ent.position.z));
			if(ccl_dampa && ccl_sum<ccl_dampa) da = 1-((ccl_dampa-ccl_sum)/ccl_dampa);
			if(ccl_dampb && ccl_sum>ccl_last-ccl_dampb) db = (ccl_last-ccl_sum)/ccl_dampb;
			if(ccl_sub>-1){
				if(ccl_mU) ccl_ent.subEntities[ccl_sub].velocity = ccl_ent.subEntities[ccl_sub].vectorUp.multiply((ccl_mU*bz*da*db)*f);
				if(ccl_mR) ccl_ent.subEntities[ccl_sub].velocity = ccl_ent.subEntities[ccl_sub].vectorRight.multiply((ccl_mR*bz*da*db)*f);
				if(ccl_mF) ccl_ent.subEntities[ccl_sub].velocity = ccl_ent.subEntities[ccl_sub].vectorForward.multiply((ccl_mF*bz*da*db)*f);
			} else {
				if(ccl_mU) ccl_ent.velocity = ccl_ent.vectorUp.multiply((ccl_mU*bz*da*db)*f);
				if(ccl_mR) ccl_ent.velocity = ccl_ent.vectorRight.multiply((ccl_mR*bz*da*db)*f);
				if(ccl_mF) ccl_ent.velocity = ccl_ent.vectorForward.multiply((ccl_mF*bz*da*db)*f);
			}
			var s = ccl_tar.position.add(ccl_offset).distanceTo(ccl_ent.subEntities[ccl_sub].position);
			if(s<ccl_ent.subEntities[ccl_sub].collisionRadius*2){ccl_sum=9999999;}
			return;
		});
		this.ccl_briefing_fcbs.push(this.ccl_briefing_fcb);
		return;
	},
	/* Rotation.
		ent			Entity. If not specified mission.displayModel.
		sub			SubEntity. If -1 main entity is used, otherwise ent.subEntities[sub].
		last		Number. Duration for fcb.
		rX			Number. Radians X.
		rY			Number. Radians Y.
		rZ			Number. Radians Z.
		basez		Boolean. If true Z position will be taken into account.
		dampa		Number. Linear dampening duration for start.
		dampb		Number. Linear dampening duration for end. */
	fcbRotation: function(ent,sub,last,rX,rY,rZ,basez,dampa,dampb){
		var ccl_sum = 0,ccl_sub = sub,ccl_last = last,ccl_delta=this.ccl_defaultDelta,ccl_rX = rX,ccl_rY = rY,ccl_rZ = rZ,ccl_ent = ent,ccl_basez = basez,ccl_dampa = dampa,ccl_dampb = dampb;
		if(!ent) ccl_ent = mission.displayModel;
		this.ccl_briefing_fcb = addFrameCallback(function(delta){
			if(!delta || !ccl_ent || !ccl_ent.isValid) return;
			var f=1-(ccl_delta-delta);
			ccl_sum += (delta*f);
			if(ccl_sum>=ccl_last) return;
			var bz = 1,da = 1,db = 1;
			if(ccl_basez) bz = Math.sqrt(Math.abs(ccl_ent.position.z));
			if(ccl_dampa && ccl_sum<ccl_dampa) da = 1-((ccl_dampa-ccl_sum)/ccl_dampa);
			if(ccl_dampb && ccl_sum>ccl_last-ccl_dampb) db = (ccl_last-ccl_sum)/ccl_dampb;
			if(ccl_sub>-1){
				if(ccl_rX) ccl_ent.subEntities[ccl_sub].orientation = ccl_ent.subEntities[ccl_sub].orientation.rotateX((ccl_rX*bz*da*db)*f);
				if(ccl_rY) ccl_ent.subEntities[ccl_sub].orientation = ccl_ent.subEntities[ccl_sub].orientation.rotateY((ccl_rY*bz*da*db)*f);
				if(ccl_rZ) ccl_ent.subEntities[ccl_sub].orientation = ccl_ent.subEntities[ccl_sub].orientation.rotateZ((ccl_rZ*bz*da*db)*f);
			} else {
				if(ccl_rX) ccl_ent.orientation = ccl_ent.orientation.rotateX((ccl_rX*bz*da*db)*f);
				if(ccl_rY) ccl_ent.orientation = ccl_ent.orientation.rotateY((ccl_rY*bz*da*db)*f);
				if(ccl_rZ) ccl_ent.orientation = ccl_ent.orientation.rotateZ((ccl_rZ*bz*da*db)*f);
			}
			return;
		});
		this.ccl_briefing_fcbs.push(this.ccl_briefing_fcb);
		return;
	},
	/* Preserve orientation/position.
		ent			Entity. To be reoriented. If not specified mission.displayModel.
		sub			SubEntity. If -1 main entity is used, otherwise ent.subEntities[sub].
		last		Number. Duration for fcb.
		tar			Entity. Target subEntity.
		dist		Boolean. Keep its distance.
		inheritFE	Boolean. Bind fuel and energy too.
		swap		Boolean. Flip orientation. */
	fcbSetBinding: function(ent,sub,last,tar,dist,inheritFE,swap){
		var ccl_sum = 0,ccl_ent = ent,ccl_sub = sub,ccl_last = last,ccl_tar = tar,ccl_dist = new Vector3D(),ccl_inherit = inheritFE,ccl_swap = swap;
		if(ccl_sub===-1) ccl_ent = mission.displayModel;
		else ccl_ent = mission.displayModel.subEntities[ccl_sub];
		if(tar===-1) ccl_tar = mission.displayModel;
		else ccl_tar = mission.displayModel.subEntities[tar];
		if(swap) ccl_swap = ccl_ent.orientation;
		if(dist) ccl_dist = ccl_tar.position.subtract(ccl_ent.position);
		this.ccl_briefing_fcb = addFrameCallback(function(delta){
			if(!delta || !ccl_ent || !ccl_tar || !ccl_ent.isValid || !ccl_tar.isValid) return;
			ccl_sum += delta;
			if(ccl_sum>=ccl_last) return;
			var p = ccl_tar.position;
			var o = ccl_tar.orientation;
			if(ccl_dist) p = p.subtract(ccl_dist.rotateBy(o));
			if(ccl_swap) o = o.rotate(ccl_tar.vectorUp,-Math.PI);
			ccl_ent.orientation = o;
			ccl_ent.position = p;
			if(ccl_inherit){
				ccl_ent.energy = ccl_tar.energy;
				ccl_ent.fuel = ccl_tar.fuel;
			}
			return;
		});
		this.ccl_briefing_fcbs.push(this.ccl_briefing_fcb);
		return;
	},
	/* Set Property
		ent			Entity. If not specified mission.displayModel.
		sub			SubEntity. If -1 main entity is used, otherwise ent.subEntities[sub].
		prop		String. Property name.
		value		Value for the property. If last specified current value added last times.
		last		Number. Duration for fcb.
		dampa		Number. Linear dampening duration for start.
		dampb		Number. Linear dampening duration for end. */
	fcbSetProp: function(ent,sub,prop,value,last,dampa,dampb){
		var ccl_ent = ent;
		if(!ent) ccl_ent = mission.displayModel;
		if(!last){
			if(sub>-1) ccl_ent.subEntities[sub][prop] = value;
			else ccl_ent[prop] = value;
		} else {
			var ccl_sum = 0,ccl_sub = sub,ccl_last = last,ccl_prop = prop,ccl_value = value,ccl_dampa = dampa,ccl_dampb = dampb,ccl_delta=this.ccl_defaultDelta;
			this.ccl_briefing_fcb = addFrameCallback(function(delta){
				if(!delta || !ccl_ent || !ccl_ent.isValid) return;
				var f=1-(ccl_delta-delta);
				ccl_sum += (delta*f);
				if(ccl_sum>=ccl_last) return;
				var da = 1,db = 1;
				if(ccl_dampa && ccl_sum<ccl_dampa) da = 1-((ccl_dampa-ccl_sum)/ccl_dampa);
				if(ccl_dampb && ccl_sum>ccl_last-ccl_dampb) db = (ccl_last-ccl_sum)/ccl_dampb;
				if(ccl_sub>-1) ccl_ent.subEntities[ccl_sub][ccl_prop] += ccl_value;
				else ccl_ent[ccl_prop] += ccl_value*f;
				return;
			});
			this.ccl_briefing_fcbs.push(this.ccl_briefing_fcb);
			return;
		}
		return;
	},
	/* Walk.
		ent			Entity. If not specified mission.displayModel.
		sub			SubEntity. If -1 main entity is used, otherwise ent.subEntities[sub].
		last		Number. Duration for fcb.
		steps		Number. Divider for duration.
		movez		Number.
		friction	Number. Modifier for Y movement
		dampa		Number. Linear dampening duration for start.
		dampb		Number. Linear dampening duration for end. */
	fcbWalk: function(ent,sub,last,steps,movez,friction,dampa,dampb){
		var ccl_sum = 0,ccl_ent = ent,ccl_sub = sub,ccl_last = last,ccl_delta=this.ccl_defaultDelta,ccl_dampa = dampa,ccl_dampb = dampb,ccl_fac = last/steps,ccl_movez = movez,ccl_friction = friction;
		if(!ent) ccl_ent = mission.displayModel;
		this.ccl_briefing_fcb = addFrameCallback(function(delta){
			if(!delta || !ccl_ent || !ccl_ent.isValid) return;
			var f=1-(ccl_delta-delta);
			ccl_sum += (delta*f);
			if(ccl_sum>=ccl_last) return;
			var friction = 0,da = 1,db = 1,mf = 1;
			if(ccl_friction){
				friction = Math.cos(ccl_last*ccl_fac*ccl_sum*ccl_friction);
				var abs = Math.abs(friction);
				abs = abs/((1/0.9-2)*(1-abs)+1); // Bias
				friction *= abs*0.065;
			}
			if(ccl_dampa && ccl_sum<ccl_dampa) da = 1-((ccl_dampa-ccl_sum)/ccl_dampa);
			if(ccl_dampb && ccl_sum>ccl_last-ccl_dampb) db = (ccl_last-ccl_sum)/ccl_dampb;
			mf = 1+(da*db);
			if(ccl_sub>-1) ccl_ent.subEntities[ccl_sub].position = ccl_ent.subEntities[ccl_sub].position.subtract([0,friction,ccl_movez*mf*f]);
			else ccl_ent.position = ccl_ent.position.subtract([0,friction,ccl_movez*mf*f]);
			return;
		});
		this.ccl_briefing_fcbs.push(this.ccl_briefing_fcb);
		return;
	},
	/* Zoom.
		ent			Entity. If not specified mission.displayModel.
		sub			SubEntity. If -1 main entity is used, otherwise ent.subEntities[sub].
		last		Number. Duration for fcb.
		amz			Number. Multiplier for Z.
		basez		Boolean. If true Z position will be taken into account.
		dampa		Number. Linear dampening duration for start.
		dampb		Number. Linear dampening duration for end. */
	fcbZoom: function(ent,sub,last,amz,basez,dampa,dampb){
		var ccl_sum = 0,ccl_ent = ent,ccl_sub = sub,ccl_last = last,ccl_delta=this.ccl_defaultDelta,ccl_amz = amz,ccl_basez = basez,ccl_dampa = dampa,ccl_dampb = dampb;
		if(!ent) ccl_ent = mission.displayModel;
		this.ccl_briefing_fcb = addFrameCallback(function(delta){
			if(!delta || !ccl_ent || !ccl_ent.isValid) return;
			var f=1-(ccl_delta-delta);
			ccl_sum += (delta*f);
			if(ccl_sum>=ccl_last) return;
			var bz = 1,da = 1,db = 1,mf = 1;
			if(ccl_basez) bz = 1-1/Math.sqrt(Math.max(Math.abs(ccl_ent.position.z),0.001));
			if(ccl_dampa && ccl_sum<ccl_dampa) da = 1-((ccl_dampa-ccl_sum)/ccl_dampa);
			if(ccl_dampb && ccl_sum>ccl_last-ccl_dampb) db = (ccl_last-ccl_sum)/ccl_dampb;
			if(ccl_amz>1) mf = 1+(da*db*bz*(ccl_amz%1));
			else mf = 1-(f*da*db*bz*(1%ccl_amz));
			if(ccl_sub>-1){
				var pos = ccl_ent.subEntities[ccl_sub].position.multiply(mf);
				ccl_ent.subEntities[ccl_sub].position = pos;
			} else {
				var pos = ccl_ent.position.multiply(mf);
				ccl_ent.position = pos;
			}
			return;
		});
		this.ccl_briefing_fcbs.push(this.ccl_briefing_fcb);
		return;
	},
	/* Zoom background.
		bg			String. Filename with extension
		last		Number. Duration for fcb.
		w			Number. Dimension width.
		h			Number. Dimension height.
		factor		Number. Multiplier Z.
		dampa		Number. Linear dampening duration for start.
		dampb		Number. Linear dampening duration for end. */
	fcbZoomBackground: function(bg,last,w,h,factor,dampa,dampb){
		var ccl_bgf = this.ccl_briefing_bg;
		var ccl_sum = 0,ccl_bg = bg,ccl_delta=this.ccl_defaultDelta,ccl_w = w*ccl_bgf,ccl_h = h*ccl_bgf,ccl_last = last,ccl_factor = factor,ccl_dampa = dampa,ccl_dampb = dampb;
		this.ccl_briefing_bg *= factor;
		this.ccl_briefing_fcb = addFrameCallback(function(delta){
			if(!delta || !ccl_bg) return;
			var f=1-(ccl_delta-delta);
			ccl_sum += (delta*f);
			if(ccl_sum>=ccl_last) return;
			var da = 1,db = 1,mf = 1;
			if(ccl_dampa && ccl_sum<ccl_dampa) da = 1-((ccl_dampa-ccl_sum)/ccl_dampa);
			if(ccl_dampb && ccl_sum>ccl_last-ccl_dampb) db = (ccl_last-ccl_sum)/ccl_dampb;
			if(ccl_factor>1) mf = 1+(da*db*(ccl_factor%1));
			else mf = 1-(f*da*db*(1%ccl_factor));
			setScreenBackground({name:bg,width:ccl_w*mf,height:ccl_h*mf});
			return;
		});
		this.ccl_briefing_fcbs.push(this.ccl_briefing_fcb);
		return;
	},
	/* Check fcbs and log them. */
	fcbCheckAll: function(){
		if(!this.ccl_briefing_fcbs.length) return(false);
		for(var i=0;i<this.ccl_briefing_fcbs.length;i++){
			if(isValidFrameCallback(this.ccl_briefing_fcbs[i])) log("fcbCheck","valid i:"+i+" fcb:"+this.ccl_briefing_fcbs[i]+" typeof:"+typeof(this.ccl_briefing_fcbs[i]));
			else log("fcbCheck","invalid i:"+i);
		}
		return(true);
	},
	/* Clean fcbs. */
	fcbRemoveAll: function(){
		if(!this.ccl_briefing_fcbs.length) return(false);
		for(var i=0;i<this.ccl_briefing_fcbs.length;i++){
			if(isValidFrameCallback(this.ccl_briefing_fcbs[i])) removeFrameCallback(this.ccl_briefing_fcbs[i]);
		}
		this.ccl_briefing_fcb = 0;
		this.ccl_briefing_fcbs = [];
		this.ccl_briefing_bg = 1;
		return(true);
	},
	/* Stop velocity.
		ent			Entity. If not specified mission.displayModel.
		sub			SubEntity. If -1 main entity is used, otherwise ent.subEntities[sub]. */
	stopVelo: function(ent,sub){
		var ccl_ent = ent;
		if(!ent) ccl_ent = mission.displayModel;
		if(sub>-1) ccl_ent.subEntities[sub].velocity = [0,0,0];
		else ccl_ent.velocity = [0,0,0];
		return;
	},
	/* Set background image.
		png			Filename. */
	reBackground: function(png){
		setScreenBackground(png);
		return;
	},
	/* Set overlay image.
		png			Filename. */
	reOverlay: function(png){
		setScreenOverlay(png);
		return;
	},
	/* Set position.
		ent			Entity. If not specified mission.displayModel.
		sub			SubEntity. If -1 main entity is used, otherwise ent.subEntities[sub].
		pos			Vector. */
	rePosition: function(ent,sub,pos){
		var ccl_ent = ent;
		if(!ent) ccl_ent = mission.displayModel;
		if(sub>-1) ccl_ent.subEntities[sub].position = pos;
		else ccl_ent.position = pos;
		return;
	},
	/* Set orientation.
		ent			Entity. If not specified mission.displayModel.
		sub			SubEntity. If -1 main entity is used, otherwise ent.subEntities[sub].
		ori			Quaternion. */
	reOrient: function(ent,sub,ori){
		var ccl_ent = ent;
		if(!ent) ccl_ent = mission.displayModel;
		if(sub>-1) ccl_ent.subEntities[sub].orientation = ori;
		else ccl_ent.orientation = ori;
		return;
	},
	/* Set materials and/or shaders.
		ent			Entity. If not specified mission.displayModel.
		sub			SubEntity. If -1 main entity is used, otherwise ent.subEntities[sub].
		mat			materials object.
		sha			shader object. */
	reTexture: function(ent,sub,mat,sha){
		var ccl_ent = ent;
		if(!ent) ccl_ent = mission.displayModel;
		if(sub>-1) ccl_ent.subEntities[sub].setMaterials(mat,sha);
		else ccl_ent.setMaterials(mat,sha);
		return;
	},
	/* Set Shader properties
		ent			Entity. If not specified mission.displayModel.
		sub			SubEntity. If -1 main entity is used, otherwise ent.subEntities[sub].
		tex			Array. Textures.
		uni			Array. Property names.
		values		Array. Values for the property. */
	reShaderProps: function(ent,sub,tex,uni,values){
		var ccl_ent = ent,a,b,flagM;
		if(!ent) ccl_ent = mission.displayModel;
		if(sub>-1) a = ccl_ent.subEntities[sub].getShaders();
		else a = ccl_ent.getShaders();
		b = Object.keys(a);
		if(!b.length){
			if(sub>-1) a = ccl_ent.subEntities[sub].getMaterials();
			else a = ccl_ent.getMaterials();
			flagM = 1;
			b = Object.keys(a);
		}
		if(!b.length) return;
		if(tex.length) for(var i=0;i<tex.length;i++) a[b[0]].textures=tex;
		if(uni.length) for(var i=0;i<uni.length;i++) a[b[0]].uniforms[uni[i]].value=values[i];
		if(flagM){
			if(sub>-1) ccl_ent.subEntities[sub].setMaterials(a);
			else ccl_ent.setMaterials(a);
		} else {
			if(sub>-1) ccl_ent.subEntities[sub].setShaders(a);
			else ccl_ent.setShaders(a);
		}
		return;
	},
	/* Missionscreen model corner positioning
		level		Number. Works best with values between 0 and 0.35.
		signx		Number. Used as sign mantissa (-1...1) for X axis.
		signy		Number. Used as sign mantissa (-1...1) for Y axis.
		further		Number. Multiplier for Z axis. Defaults to 1.3. */
	screenCornerPos: function(level,signx,signy,further){
		var pos = mission.displayModel.position,w = 1024/oolite.gameSettings.gameWindow.width,h = 768/oolite.gameSettings.gameWindow.height;
		pos.x = level*pos.z*signx;
		pos.y = level*pos.z*0.75*signy;
		if(further) pos.z *= further;
		else pos.z *= 1.3;
		var wh = w/h;
		pos = pos.add([w*wh-1,h*wh-1,0]);
		mission.displayModel.position=pos;
		return;
	}
};
