"use strict";
this.name = "Cabal_Common_Keyboard";
this.author = "Svengali";
this.copyright = "(C)2010-2013, License:CC-by";
this.description = "Libraryscript Keyboard";
this.version = "1.7";
/* function: start()
Parameters:
	who - String. The name of a worldScript which implements the keyboard callback.
	min - Number. Optional - minimum length for completion, default(4).
	mode - Number. Optional - 1(only alphabetical), 2(only numeric), 3(hexadecimal), default 4(alphanumeric).
	scpic - String. Optional. Name for screenbackground build upon scpic + suffix. The mode defines which one will be used.
	scovl - String. Optional. Filename for screenoverlay (with fileextension). Default null.
	scmod - String. Optional. Role for the used model. Default 'cabal_common_key'.

Returns:
nothing
> worldScripts.Cabal_Common_Keyboard.start(this.name,5,1);

Suffixes are :
- 1 - '_keyboard_alpha.png'
- 2 - '_keyboard_nums.png'
- 3 - '_keyboard_hex.png'
- 4 - '_keyboard.png'
*/
this.start = function(who,min,mode,scpic,scovl,scmod)
{
	if(!player.ship.docked) return;
	this.keyboard = new Object({ini: true,input: "",keyboardSound: new SoundSource(),loop: false,sound: 'cabal_common_key.ogg',
		maxRows: 4,model: 'cabal_common_key',modelSC: null,pic: 'cabal_common_keyboard.png',overlay: null,ratioX: 1,ratioY: 1,
		rowsT: [],rowsX: [],rowsY: [],toCall: null,toMin: 4,X: 4,Y: 2});
	if(who) this.keyboard.toCall = who;
	if(min && !isNaN(min) && min>0) this.keyboard.toMin = min;
	else this.keyboard.toMin = 4;
	var rowsY_c = [69,46,23,-1],rowsX_c = [[-109,-85,-61,-36,-12.5,12,36.5,61,85,110],[-109.5,-85,-60.5,-36,-12.5,12.5,36.5,61,85,110],[-99.5,-75,-51,-26,-2,22,46.5,71,95],[-86,-61.5,-37.5,-13,12,36,61]];
	var rowsT_c = [["1","2","3","4","5","6","7","8","9","0"],["Q","W","E","R","T","Y","U","I","O","P"],["A","S","D","F","G","H","J","K","L"],["Z","X","C","V","B","N","M"]];
	var rowsY_ch = [69,46],rowsX_ch = [[-109,-85,-61,-36,-12.5,12,36.5,61,85,110],[-60.5,-36,-12.5,12.5,36.5,61]];
	var rowsT_ch = [["1","2","3","4","5","6","7","8","9","0"],["A","B","C","D","E","F"]];
	switch(mode){
		case 1: this.keyboard.rowsX = [rowsX_c[1],rowsX_c[2],rowsX_c[3]];
			this.keyboard.rowsY = [rowsY_c[1],rowsY_c[2],rowsY_c[3]];
			this.keyboard.rowsT = [rowsT_c[1],rowsT_c[2],rowsT_c[3]];
			this.keyboard.Y = 1;
			this.keyboard.maxRows = 2;
			if(scpic) this.keyboard.pic = scpic+'_keyboard_alpha.png';
			else this.keyboard.pic = 'cabal_common_keyboard_alpha.png';
			break;
		case 2: this.keyboard.rowsX = [rowsX_c[0]];
			this.keyboard.rowsY = [rowsY_c[0]];
			this.keyboard.rowsT = [rowsT_c[0]];
			this.keyboard.Y = 0;
			this.keyboard.maxRows = 0;
			if(scpic) this.keyboard.pic = scpic+'_keyboard_nums.png';
			else this.keyboard.pic = 'cabal_common_keyboard_nums.png';
			break;
		case 3: this.keyboard.rowsX = rowsX_ch;
			this.keyboard.rowsY = rowsY_ch;
			this.keyboard.rowsT = rowsT_ch;
			this.keyboard.Y = 0;
			this.keyboard.maxRows = 1;
			if(scpic) this.keyboard.pic = scpic+'_keyboard_hex.png';
			else this.keyboard.pic = 'cabal_common_keyboard_hex.png';
			break;
		default: this.keyboard.rowsX = rowsX_c;
			this.keyboard.rowsY = rowsY_c;
			this.keyboard.rowsT = rowsT_c;
			this.keyboard.Y = 2;
			this.keyboard.maxRows = 3;
			if(scpic) this.keyboard.pic = scpic+'_keyboard.png';
			else this.keyboard.pic = 'cabal_common_keyboard.png';
	}
	this.keyboard.X = 4;
	var r = (oolite.gameSettings.gameWindow.width/oolite.gameSettings.gameWindow.height),c = 1024/768;
	if(r>c){
		var ccX = (r%c)/1.5,ccY = (r%c)/2;
		this.keyboard.ratioX = 1-ccX;
		this.keyboard.ratioY = 1-ccY;
	} else {
		this.keyboard.ratioX = 1;
		this.keyboard.ratioY = 1;
	}
	if(!player.ship.docked){
		if(this.keyboard) delete this.keyboard;
		return;
	}
	if(scovl) this.keyboard.overlay = scovl;
	if(scmod) this.keyboard.model = scmod;
	this.keyboard.keyboardSound.loop = false;
	this.keyboard.keyboardSound.sound = 'cabal_common_key.ogg';
	this.keyboardShow();
	this.keyboard.modelSC.lightsActive = true;
	return;
};
/* function: keyboardEval()
Workaround to change the context of this!!!
*/
this.keyboardEval = function(choice){worldScripts.Cabal_Common_Keyboard.keyboardChoice(choice); return;};
/* function: keyboardChoice()
Evaluates the user choice.
When <keyboard.toCall> is specified and user confirms or aborts the keyboard input.

Callback:
- "" - String. if user aborts.
- <keyboard.input> - String. If user confirmed input.
> worldScripts[this.keyboard.toCall].Cabal_Common_Keyboard_Output(this.keyboard.input);
*/
this.keyboardChoice = function(choice)
{
	switch(choice){
		case 'CABAL_COMMON_KEYBOARDA':
			this.keyboard.X--;
			if(this.keyboard.X<0) this.keyboard.X = this.keyboard.rowsX[this.keyboard.Y].length-1;
			this.keyboardShow(); break;
		case 'CABAL_COMMON_KEYBOARDB':
			this.keyboard.Y--;
			if(this.keyboard.Y<0) this.keyboard.Y = this.keyboard.maxRows;
			if(this.keyboard.X>this.keyboard.rowsX[this.keyboard.Y].length-1) this.keyboard.X = this.keyboard.rowsX[this.keyboard.Y].length-1;
			this.keyboardShow(); break;
		case 'CABAL_COMMON_KEYBOARDC':
			this.keyboard.Y++;
			if(this.keyboard.Y>this.keyboard.maxRows) this.keyboard.Y = 0;
			if(this.keyboard.X>this.keyboard.rowsX[this.keyboard.Y].length-1) this.keyboard.X = this.keyboard.rowsX[this.keyboard.Y].length-1;
			this.keyboardShow(); break;
		case 'CABAL_COMMON_KEYBOARDD':
			this.keyboard.input += this.keyboard.rowsT[this.keyboard.Y][this.keyboard.X];
			this.keyboardShow(); break;
		case 'CABAL_COMMON_KEYBOARDE':
			if(this.keyboard.input.length) this.keyboard.input = this.keyboard.input.substr(0,this.keyboard.input.length-1);
			this.keyboardShow(); break;
		case 'CABAL_COMMON_KEYBOARDY':
			if(this.keyboard.toCall) worldScripts[this.keyboard.toCall].Cabal_Common_Keyboard_Output("");
			this.killModelview(); break;
		case 'CABAL_COMMON_KEYBOARDZ':
			if(this.keyboard.toCall) worldScripts[this.keyboard.toCall].Cabal_Common_Keyboard_Output(this.keyboard.input);
			this.killModelview(); break;
	}
	return;
};
this.keyboardShow = function()
{
	this.keyboard.keyboardSound.play();
	if(this.keyboard.input.length<this.keyboard.toMin){
		if(this.keyboard.overlay) mission.runScreen({title:"Terminal",choicesKey:'CABAL_COMMON_KEYBOARD_A',model:this.keyboard.model,spinModel:false,background:this.keyboard.pic,overlay:this.keyboard.overlay},this.keyboardEval);
		else mission.runScreen({title:"Terminal",choicesKey:'CABAL_COMMON_KEYBOARD_A',model:this.keyboard.model,spinModel:false,background:this.keyboard.pic},this.keyboardEval);
	} else {
		if(this.keyboard.overlay) mission.runScreen({title:"Terminal",choicesKey:'CABAL_COMMON_KEYBOARD_B',model:this.keyboard.model,spinModel:false,background:this.keyboard.pic,overlay:this.keyboard.overlay},this.keyboardEval);
		else mission.runScreen({title:"Terminal",choicesKey:'CABAL_COMMON_KEYBOARD_B',model:this.keyboard.model,spinModel:false,background:this.keyboard.pic},this.keyboardEval);
	}
	this.keyboard.modelSC = mission.displayModel;
	this.keyboard.modelSC.orientation = [1,-1,0,0]; // Makes the model invisible
	if(this.keyboard.ini){
		this.keyboard.modelSC.position = [this.keyboard.rowsX[this.keyboard.Y][4]*this.keyboard.ratioX,this.keyboard.rowsY[this.keyboard.Y]*this.keyboard.ratioY,500];
		delete this.keyboard.ini;
	} else this.keyboard.modelSC.position = [this.keyboard.rowsX[this.keyboard.Y][this.keyboard.X]*this.keyboard.ratioX,this.keyboard.rowsY[this.keyboard.Y]*this.keyboard.ratioY,500];
	mission.addMessageText("\n    User input: "+this.keyboard.input+"\n\n\f\f\f\f\f\f\f\f\f\f\f\f\f\f\f\f\f\f\f\f\f\f\f\f\f\f\f\fMinimum length: "+this.keyboard.toMin+" signs.");
	this.keyboard.modelSC.lightsActive = true;
	return;
};
this.killModelview = this.shipWillLaunchFromStation = function()
{
	if(this.keyboard) delete this.keyboard;
	return;
};
