"use strict";
this.name = "cabal_common_oxps_ov";
this.author = "Svengali";
this.copyright = "(C)2010-2013, License:CC-by";
this.description = "Generic Overlay script.";
this.version = "1.7";

/*	As view_positions are not exposed positioning is practically impossible
	if shaders are off and therefor only roughly implemented.
*/
// Defaults
this.cclov_tar = player.ship;
this.cclov_blendC = -1;
this.cclov_blendI = -1;
this.cclov_blendA = -1;
this.cclov_noShade = false;

this.effectSpawned = function()
{
	this.ovFCBID = addFrameCallback(this.repos.bind(this));
}
this.effectRemoved = function()
{
	removeFrameCallback(this.ovFCBID);
}
this.repos = function(delta)
{
	if(!player.ship.isValid || !this.cclov_tar.isValid) this.visualEffect.remove();
	if(!delta) return;
	if(this.cclov_blendA!==-1 && clock.absoluteSeconds>this.cclov_blendA) this.visualEffect.remove();
	else {
		if(this.visualEffect.shaderFloat1<1) this.visualEffect.shaderFloat1 += delta;
		if(this.visualEffect.shaderFloat2>0){
			this.visualEffect.shaderFloat2 -= delta;
			if(this.visualEffect.shaderInt1>0) this.visualEffect.shaderInt1 -= 1;
			if(this.visualEffect.shaderInt2>0) this.visualEffect.shaderInt2 -= 1;
		} else {
			if(this.cclov_blendC!==-1 && clock.absoluteSeconds>this.cclov_blendC){
				if(this.visualEffect.shaderInt1<20) this.visualEffect.shaderInt1 += 1;
				else if(this.cclov_autoremove){
					this.visualEffect.remove();
					return;
				}
			}
			if(this.cclov_blendI!==-1 && clock.absoluteSeconds>this.cclov_blendI){
				if(this.visualEffect.shaderInt2<20) this.visualEffect.shaderInt2 += 1;
				else if(this.cclov_autoremove){
					this.visualEffect.remove();
					return;
				}
			}
		}
		if(!this.cclov_tar.isValid) return; // needs this check. strange.
		var bb = this.cclov_tar.boundingBox;
		if(this.cclov_tar.isPlayer){
			switch(this.cclov_tar.viewDirection){
				case "VIEW_FORWARD":
					if(!this.cclov_noShade) this.visualEffect.position = this.cclov_tar.position.add(this.cclov_tar.vectorForward.multiply(bb.z));
					else this.visualEffect.position = this.cclov_tar.position.add(this.cclov_tar.vectorForward.multiply(75)).add(this.cclov_tar.vectorUp.multiply(15)).subtract(this.visualEffect.shaderVector1.multiply(1.2).rotateBy(this.cclov_tar.orientation));
					break;
				case "VIEW_AFT":
					if(!this.cclov_noShade) this.visualEffect.position = this.cclov_tar.position.subtract(this.cclov_tar.vectorForward.multiply(bb.z));
					else this.visualEffect.position = this.cclov_tar.position.subtract(this.cclov_tar.vectorForward.multiply(75)).add(this.cclov_tar.vectorUp.multiply(15)).subtract(this.visualEffect.shaderVector1.multiply(1.2).rotateBy(this.cclov_tar.orientation));
					break;
				case "VIEW_PORT":
					if(!this.cclov_noShade) this.visualEffect.position = this.cclov_tar.position.subtract(this.cclov_tar.vectorRight.multiply(bb.x));
					else this.visualEffect.position = this.cclov_tar.position.subtract(this.cclov_tar.vectorRight.multiply(85)).add(this.cclov_tar.vectorUp.multiply(10)).subtract(this.visualEffect.shaderVector1.multiply(1.2).rotateBy(this.cclov_tar.orientation));
					break;
				case "VIEW_STARBOARD":
					if(!this.cclov_noShade) this.visualEffect.position = this.cclov_tar.position.add(this.cclov_tar.vectorRight.multiply(bb.x));
					else this.visualEffect.position = this.cclov_tar.position.add(this.cclov_tar.vectorRight.multiply(85)).add(this.cclov_tar.vectorUp.multiply(10)).subtract(this.visualEffect.shaderVector1.multiply(1.2).rotateBy(this.cclov_tar.orientation));
					break;
				case "VIEW_CUSTOM":
					this.visualEffect.position = this.cclov_tar.position;
					break;
				case "VIEW_GUI_DISPLAY":
					this.visualEffect.shaderFloat1 = 0;
					break;
			}
		}
		if(!this.cclov_tar.isValid) return; // needs this check. strange.
		if(this.cclov_noShade) this.visualEffect.orientation = this.cclov_tar.orientation;
	}
	return;
};
